SystemOrganization addCategory: #'SqueakSource2-Core'!
SystemOrganization addCategory: #'SqueakSource2-Tests'!
SystemOrganization addCategory: #'SqueakSource2-View'!

Object subclass: #S2Entry
	instanceVariableNames: 'name title wiki tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Core'!

!S2Entry class methodsFor: 'accessing-description' stamp: 'lr 7/9/2008 14:32'!
descriptionName
	^ MAStringDescription new
		accessor: #name;
		label: 'Name';
		priority: 100;
		beRequired;
		yourself! !

!S2Entry class methodsFor: 'accessing-description' stamp: 'lr 7/9/2008 14:32'!
descriptionTags
	^ MATokenDescription new
		accessor: #tags;
		priority: 130;
		label: 'Tags';
		yourself! !

!S2Entry class methodsFor: 'accessing-description' stamp: 'lr 7/9/2008 14:32'!
descriptionTitle
	^ MAStringDescription new
		accessor: #title;
		priority: 110;
		label: 'Title';
		beRequired;
		yourself! !

!S2Entry class methodsFor: 'accessing-description' stamp: 'lr 7/9/2008 14:32'!
descriptionWiki
	^ MAMemoDescription new
		accessor: #wiki;
		priority: 120;
		label: 'Wiki';
		yourself! !

!S2Entry methodsFor: 'accessing' stamp: 'AQ 7/6/2008 17:41'!
addTag: aTag
	tags add: aTag! !

!S2Entry methodsFor: 'initialization' stamp: 'AQ 7/6/2008 17:38'!
initialize
	super initialize.
	tags := Set new.! !

!S2Entry methodsFor: 'testing' stamp: 'lr 7/7/2008 14:36'!
isEditableBy: aUser
	self subclassResponsibility! !

!S2Entry methodsFor: 'testing' stamp: 'lr 7/7/2008 14:36'!
isVisibleBy: aUser
	self subclassResponsibility! !

!S2Entry methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:31'!
name
	^ name! !

!S2Entry methodsFor: 'accessing' stamp: 'AQ 7/6/2008 17:37'!
name: aString 
	name := aString! !

!S2Entry methodsFor: 'accessing' stamp: 'AQ 7/7/2008 11:37'!
removeTag: aTag
	tags remove: aTag! !

!S2Entry methodsFor: 'accessing' stamp: 'AQ 6/18/2008 17:56'!
tags
	^tags! !

!S2Entry methodsFor: 'accessing' stamp: 'lr 7/9/2008 14:33'!
tags: aCollection
	tags := aCollection! !

!S2Entry methodsFor: 'accessing' stamp: 'AQ 6/30/2008 10:56'!
title
	^title! !

!S2Entry methodsFor: 'accessing' stamp: 'AQ 7/6/2008 17:39'!
title: aString
	title := aString! !

!S2Entry methodsFor: 'accessing' stamp: 'AQ 6/18/2008 17:56'!
wiki
	^wiki! !

!S2Entry methodsFor: 'accessing' stamp: 'AQ 7/6/2008 17:37'!
wiki: anObject
	wiki := anObject! !

S2Entry subclass: #S2Member
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Core'!

S2Member subclass: #S2Group
	instanceVariableNames: 'users admins'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Core'!

!S2Group methodsFor: 'accessing' stamp: 'AQ 7/9/2008 12:13'!
addAdmin: aUser
	admins add: aUser.
	aUser groups add: self! !

!S2Group methodsFor: 'accessing' stamp: 'AQ 7/6/2008 17:30'!
addUser: aUser
	users add: aUser.
	aUser groups add: self! !

!S2Group methodsFor: 'accessing' stamp: 'AQ 7/9/2008 12:13'!
admins
	^ admins! !

!S2Group methodsFor: 'initialization' stamp: 'AQ 7/9/2008 12:14'!
initialize
	super initialize.
	users := Set new.
	admins := Set new.! !

!S2Group methodsFor: 'testing' stamp: 'AQ 7/9/2008 12:22'!
isEditableBy: aUser
	^ aUser superuser or: [admins includes: aUser].! !

!S2Group methodsFor: 'testing' stamp: 'AQ 7/9/2008 12:34'!
isVisibleBy: aUser
	^ aUser superuser or: [admins includes: aUser] or: [users includes: aUser].! !

!S2Group methodsFor: 'accessing' stamp: 'AQ 7/9/2008 12:13'!
removeAdmin: aUser
	admins remove: aUser.
	aUser groups remove: self! !

!S2Group methodsFor: 'accessing' stamp: 'AQ 7/6/2008 19:47'!
removeUser: aUser
	users remove: aUser.
	aUser groups remove: self! !

!S2Group methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:46'!
users
	^ users! !

!S2Member methodsFor: 'initialization' stamp: 'AQ 7/6/2008 17:35'!
initialize
	super initialize.
		projects := Set new! !

!S2Member methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:19'!
projects
	^projects! !

S2Member subclass: #S2Person
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Core'!

S2Person subclass: #S2AnonymousUser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Core'!

!S2AnonymousUser methodsFor: 'as yet unclassified' stamp: 'lr 7/9/2008 14:22'!
initialize
	super initialize.
	name := 'Ananymous'.! !

!S2Person methodsFor: 'as yet unclassified' stamp: 'lr 7/9/2008 15:26'!
superuser
	^false! !

S2Person subclass: #S2User
	instanceVariableNames: 'email password superuser groups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Core'!

!S2User methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:46'!
addGroup: aGroup
	groups add: aGroup.
	aGroup users add: self! !

!S2User methodsFor: 'accessing' stamp: 'AQ 6/30/2008 11:57'!
email
	^ email! !

!S2User methodsFor: 'accessing' stamp: 'AQ 6/30/2008 11:57'!
email: anObject
	email := anObject! !

!S2User methodsFor: 'accessing' stamp: 'AQ 6/30/2008 11:57'!
groups
	^ groups! !

!S2User methodsFor: 'private' stamp: 'lr 7/9/2008 15:01'!
hashPassword: aString 
	^ aString isEmptyOrNil ifFalse: [ SecureHashAlgorithm new hashMessage: aString ]! !

!S2User methodsFor: 'initialization' stamp: 'lr 6/30/2008 14:47'!
initialize
	super initialize.
	superuser := false.
	groups := Set new! !

!S2User methodsFor: 'testing' stamp: 'AQ 7/9/2008 11:49'!
isEditableBy: aUser
	^ (aUser = self or: [aUser superuser]).! !

!S2User methodsFor: 'testing' stamp: 'AQ 7/9/2008 12:31'!
isVisibleBy: aUser
	^ (aUser class = S2User).! !

!S2User methodsFor: 'accessing' stamp: 'lr 7/9/2008 15:01'!
password: aString 
	password := self hashPassword: aString! !

!S2User methodsFor: 'accessing' stamp: 'AQ 7/6/2008 19:47'!
removeGroup: aGroup
	groups remove: aGroup.
	aGroup users remove: self! !

!S2User methodsFor: 'accessing' stamp: 'AQ 6/30/2008 11:57'!
superuser
	^ superuser! !

!S2User methodsFor: 'accessing' stamp: 'AQ 6/30/2008 11:58'!
superuser: aBoolean
	superuser := aBoolean! !

!S2User methodsFor: 'testing' stamp: 'lr 7/9/2008 15:02'!
verifyPassword: aString
	^ (self hashPassword: aString) = password! !

S2Entry subclass: #S2Project
	instanceVariableNames: 'license state rating visibility admins developers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Core'!

!S2Project methodsFor: 'accessing' stamp: 'AQ 7/6/2008 19:55'!
addAdmin: aUserOrGroup
	admins add: aUserOrGroup.
	aUserOrGroup addProject: self! !

!S2Project methodsFor: 'accessing' stamp: 'AQ 7/6/2008 19:57'!
addDeveloper: aUserOrGroup
	developers add: aUserOrGroup.
	aUserOrGroup addProject: self! !

!S2Project methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:34'!
admins
	^ admins! !

!S2Project methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:39'!
developers
	^ developers! !

!S2Project methodsFor: 'initialization' stamp: 'AQ 7/9/2008 12:56'!
initialize
	super initialize.
	developers := Set new.
	admins := Set new.
	rating := 0.
	visibility := #hidden.
	state := 'Created'! !

!S2Project methodsFor: 'testing' stamp: 'AQ 7/9/2008 12:50'!
isEditableBy: aUser
	^ aUser superuser or: [admins includes: aUser].! !

!S2Project methodsFor: 'testing' stamp: 'AQ 7/9/2008 12:55'!
isVisibleBy: aUser
	^ aUser superuser or: [admins includes: aUser] or: [developers includes: aUser] or: visibility = #visible.! !

!S2Project methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:34'!
license
	^ license! !

!S2Project methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:34'!
license: anObject
	license := anObject! !

!S2Project methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:34'!
rating
	^ rating! !

!S2Project methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:34'!
rating: anObject
	rating := anObject! !

!S2Project methodsFor: 'accessing' stamp: 'AQ 7/7/2008 11:47'!
removeAdmin: aUserOrGroup
	admins remove: aUserOrGroup.
	aUserOrGroup removeProject: self! !

!S2Project methodsFor: 'accessing' stamp: 'AQ 7/7/2008 11:47'!
removeDeveloper: aUserOrGroup
	developers remove: aUserOrGroup.
	aUserOrGroup removeProject: self! !

!S2Project methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:34'!
state
	^ state! !

!S2Project methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:34'!
state: anObject
	state := anObject! !

!S2Project methodsFor: 'accessing' stamp: 'AQ 7/9/2008 12:56'!
visibility
	^ visibility
	
"
#hidden
#visible
#writeable
"! !

!S2Project methodsFor: 'accessing' stamp: 'lr 7/7/2008 14:35'!
visibility: aCaracter
	visibility := aCaracter

"
#hidden
#visible
#writeable
"
! !

S2Entry subclass: #S2Root
	instanceVariableNames: 'anonymous users groups projects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Core'!

S2Root class
	instanceVariableNames: 'Default'!

S2Root class
	instanceVariableNames: 'Default'!

!S2Root class methodsFor: 'accessing' stamp: 'lr 7/7/2008 14:29'!
default
	^ Default! !

!S2Root class methodsFor: 'initialization' stamp: 'lr 7/7/2008 14:29'!
initialize
	Default := self new! !

!S2Root methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:35'!
addGroup: aGroup
	groups add: aGroup! !

!S2Root methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:35'!
addProject: aProject
	projects add: aProject! !

!S2Root methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:35'!
addUser: aUser
	users add: aUser! !

!S2Root methodsFor: 'accessing' stamp: 'lr 7/9/2008 14:15'!
anonymous
	^ anonymous! !

!S2Root methodsFor: 'accessing' stamp: 'AQ 7/6/2008 20:41'!
groups
	^ groups! !

!S2Root methodsFor: 'initialization' stamp: 'lr 7/9/2008 14:16'!
initialize
	super initialize.
	anonymous := S2AnonymousUser new.
	users := Set new.
	projects := Set new.
	groups := Set new.! !

!S2Root methodsFor: 'accessing' stamp: 'AQ 7/6/2008 20:42'!
projects
	^ projects! !

!S2Root methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:37'!
removeGroup: aGroup
		groups remove: aGroup! !

!S2Root methodsFor: 'accessing' stamp: 'AQ 7/6/2008 20:52'!
removeProject: aProject
		projects remove: aProject! !

!S2Root methodsFor: 'accessing' stamp: 'AQ 7/6/2008 20:51'!
removeUser: aUser
		users remove: aUser! !

!S2Root methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:36'!
users
	^ users! !

WAComponent subclass: #S2ContentComponent
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-View'!

!S2ContentComponent class methodsFor: 'instance creation' stamp: 'lr 7/9/2008 15:24'!
on: aComponent
	^ self new initializeOn: aComponent! !

!S2ContentComponent methodsFor: 'initialization' stamp: 'lr 7/9/2008 15:21'!
initializeOn: aComponent
	root := aComponent! !

!S2ContentComponent methodsFor: 'accessing' stamp: 'lr 7/9/2008 15:20'!
root
	^ root! !

!S2ContentComponent methodsFor: 'accessing' stamp: 'lr 7/9/2008 15:21'!
user
	^ root user! !

S2ContentComponent subclass: #S2ProjectView
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-View'!

!S2ProjectView methodsFor: 'actions' stamp: 'lr 7/9/2008 14:55'!
edit
	self call: (project
		asComponent
			addValidatedForm;
			addMessage: 'Edit Project';
			yourself).! !

!S2ProjectView methodsFor: 'accessing' stamp: 'lr 7/9/2008 14:41'!
project
	^ project! !

!S2ProjectView methodsFor: 'accessing' stamp: 'lr 7/9/2008 14:41'!
project: aProject
	project := aProject! !

!S2ProjectView methodsFor: 'as yet unclassified' stamp: 'lr 7/9/2008 15:23'!
renderContentOn: html 
	html heading: 'Project' , project title.
	(self project isEditableBy: self user)
		ifTrue: [html anchor
				callback: [self edit];
				 with: 'Edit:']! !

S2ContentComponent subclass: #S2WelcomeView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-View'!

!S2WelcomeView methodsFor: 'as yet unclassified' stamp: 'lr 7/9/2008 14:50'!
renderContentOn: html
	html text: 'Welcome to SqueakSource 2'! !

WAComponent subclass: #S2RootComponent
	instanceVariableNames: 'user content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-View'!

!S2RootComponent class methodsFor: 'testing' stamp: 'AQ 7/8/2008 13:55'!
canBeRoot
	^true! !

!S2RootComponent class methodsFor: 'initialization' stamp: 'lr 7/9/2008 14:11'!
initialize
	self registerAsApplication: 'squeaksource'! !

!S2RootComponent methodsFor: 'accessing' stamp: 'lr 7/9/2008 14:50'!
children
	^ Array with: content! !

!S2RootComponent methodsFor: 'initialization' stamp: 'lr 7/9/2008 15:21'!
initialize
	super initialize.
	user := self s2root anonymous.
	content := S2WelcomeView on: self! !

!S2RootComponent methodsFor: 'actions' stamp: 'lr 7/9/2008 14:52'!
newProject
	| project |
	project := content call: (S2Project new
		asComponent
			addValidatedForm;
			addMessage: 'Create Project';
			yourself).
	project isNil
		ifFalse: [ self s2root addProject: project ]! !

!S2RootComponent methodsFor: 'rendering' stamp: 'lr 7/9/2008 14:48'!
renderContentOn: html
	html heading: 'SqueakSource 2'.
	html paragraph: user name.
	html unorderedList
		list: self s2root projects;
		callback: [ :each | self viewProject: each ].
	html anchor
		callback: [ self newProject ];
		with: 'New Project'.
	html render: content.! !

!S2RootComponent methodsFor: 'accessing' stamp: 'lr 7/9/2008 15:25'!
user
	"Answer the currently authenticated user."
	
	^ user! !

!S2RootComponent methodsFor: 'actions' stamp: 'lr 7/9/2008 15:21'!
viewProject: aProject
	content := S2ProjectView on: self.
	content project: aProject.! !

!WAComponent methodsFor: '*squeaksource2-view' stamp: 'lr 7/9/2008 14:18'!
s2root
	^ S2Root default! !

TestCase subclass: #S2EntryTest
	instanceVariableNames: 'entry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Tests'!

!S2EntryTest methodsFor: 'running' stamp: 'AQ 7/6/2008 17:47'!
setUp
	entry := S2Entry new.! !

!S2EntryTest methodsFor: 'tests' stamp: 'AQ 7/7/2008 11:40'!
testAddTags
	self assert: (entry tags isEmpty).
	
	entry addTag: 'seaside'.
	self assert: (entry tags anyOne = 'seaside').
	self assert: (entry tags size = 1)! !

!S2EntryTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 17:56'!
testName
	entry name: 'SqueakSource2'.
	self assert: (entry name = 'SqueakSource2').
	self deny: (entry name = 'Unnamed')! !

!S2EntryTest methodsFor: 'tests' stamp: 'AQ 7/7/2008 11:39'!
testRemoveTags
	self assert: (entry tags isEmpty).
	
	entry addTag: 'seaside'.
	self assert: (entry tags anyOne = 'seaside').
	
	entry removeTag: 'seaside'.
	self assert: (entry tags isEmpty)! !

!S2EntryTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 17:55'!
testTitle
	entry title: 'SqueakSource 2'.
	self assert: (entry title = 'SqueakSource 2').
	self deny: (entry title = 'Unnamed')! !

!S2EntryTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 17:54'!
testWiki
	entry wiki: 'aWiki'.
	self assert: (entry wiki = 'aWiki').
	self deny: (entry wiki = 'wikipedia')! !

TestCase subclass: #S2GroupTest
	instanceVariableNames: 'user superuser user2 group admin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Tests'!

!S2GroupTest methodsFor: 'running' stamp: 'AQ 7/9/2008 12:17'!
setUp
	user := S2User new.
	superuser := S2User new.
	superuser superuser: true.
	admin := S2User new.
	user2 := S2User new.
	group := S2Group new.! !

!S2GroupTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:27'!
testAddAdmin
	self assert: user groups isEmpty.
	self assert: group admins isEmpty.
	
	group addAdmin: admin..
	
	self assert: admin groups size = 1.
	self assert: admin groups anyOne = group.
	self assert: group admins size = 1.
	self assert: group admins anyOne = admin.! !

!S2GroupTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:26'!
testAddUser
	self assert: user groups isEmpty.
	self assert: group users isEmpty.
	
	group addUser: user.
	
	self assert: user groups size = 1.
	self assert: user groups anyOne = group.
	self assert: group users size = 1.
	self assert: group users anyOne = user! !

!S2GroupTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:23'!
testIsEditableBy
	group addUser: user.
	group addAdmin: admin.
	
	self deny: (group isEditableBy: user).
	self assert: (group isEditableBy: admin).
	self deny: (group isEditableBy: user2).
	self assert: (group isEditableBy: superuser).
	! !

!S2GroupTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:35'!
testIsVisibleBy
	group addUser: user.
	group addAdmin: admin.
	
	self assert: (group isVisibleBy: user).
	self assert: (group isVisibleBy: admin).
	self deny: (group isVisibleBy: user2).
	self assert: (group isVisibleBy: superuser).
	! !

!S2GroupTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:28'!
testRemoveAdmin
	group addAdmin: admin.
	self assert: admin groups size = 1.
	self assert: group admins size = 1.
	group removeAdmin: admin.
	self assert: group admins size = 0.
	self assert: admin groups size = 0! !

!S2GroupTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:27'!
testRemoveUser
	group addUser: user.
	self assert: user groups size = 1.
	self assert: group users size = 1.
	group removeUser: user.
	self assert: group users size = 0.
	self assert: user groups size = 0! !

TestCase subclass: #S2MemberTest
	instanceVariableNames: 'user group project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Tests'!

!S2MemberTest methodsFor: 'running' stamp: 'AQ 7/6/2008 20:07'!
setUp
	user := S2User new.
	group := S2Group new.
	project := S2Project new! !

!S2MemberTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:44'!
testGroupAddProject
	
	self assert: (group projects isEmpty).
	
	group addProject: project.
	self assert: group projects size = 1.
	self assert: (group projects anyOne = project).! !

!S2MemberTest methodsFor: 'tests' stamp: 'AQ 7/7/2008 11:43'!
testGroupRemoveProject
	
	self assert: (group projects isEmpty).
	group addProject: project.
	self assert: group projects size = 1.
	self assert: (group projects anyOne = project).
	
	group removeProject: project.
	self assert: group projects size = 0.
	self assert: group projects isEmpty! !

!S2MemberTest methodsFor: 'tests' stamp: 'lr 6/30/2008 14:47'!
testUserAddGroup
	self assert: user groups isEmpty.
	self assert: group users isEmpty.
	
	user addGroup: group.
	
	self assert: user groups size = 1.
	self assert: user groups anyOne = group.
	self assert: group users size = 1.
	self assert: group users anyOne = user! !

!S2MemberTest methodsFor: 'tests' stamp: 'AQ 7/7/2008 11:41'!
testUserAddProject
	
	self assert: (user projects isEmpty).
	
	user addProject: project.
	self assert: user projects size = 1.
	self assert: (user projects anyOne = project).! !

!S2MemberTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 19:48'!
testUserRemoveGroup
	user addGroup: group.
	self assert: user groups size = 1.
	self assert: group users size = 1.
	
	user removeGroup: group.
	self assert: user groups size = 0.
	self assert: group users size = 0! !

!S2MemberTest methodsFor: 'tests' stamp: 'AQ 7/7/2008 11:42'!
testUserRemoveProject
	
	self assert: (user projects isEmpty).
	user addProject: project.
	self assert: user projects size = 1.
	self assert: (user projects anyOne = project).
	
	user removeProject: project.
	self assert: user projects size = 0.
	self assert: user projects isEmpty! !

TestCase subclass: #S2ProjectTest
	instanceVariableNames: 'group project superuser admin developer user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Tests'!

!S2ProjectTest methodsFor: 'running' stamp: 'AQ 7/9/2008 12:53'!
setUp
	developer := S2User new.
	admin := S2User new.
	user := S2User new.
	superuser := S2User new.
	superuser superuser: true.
	group := S2Group new.
	project := S2Project new! !

!S2ProjectTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:45'!
testAddAdmin
	self assert: project admins size = 0.
	self assert: admin projects size = 0.
	self assert: group projects size = 0.
	self assert: admin projects isEmpty.
	self assert: group projects isEmpty.
	project addAdmin: admin.
	self assert: project admins size = 1.
	self assert: admin projects size = 1.
	self assert: group projects size = 0.
	self deny: admin projects isEmpty.
	self assert: group projects isEmpty.
	project addAdmin: group.
	self assert: project admins size = 2.
	self assert: admin projects size = 1.
	self assert: group projects size = 1.
	self deny: admin projects isEmpty.
	self deny: group projects isEmpty! !

!S2ProjectTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:45'!
testAddDeveloper
	self assert: project developers size = 0.
	self assert: developer projects size = 0.
	self assert: group projects size = 0.
	self assert: developer projects isEmpty.
	self assert: group projects isEmpty.
	project addDeveloper: developer.
	self assert: project developers size = 1.
	self assert: developer projects size = 1.
	self assert: group projects size = 0.
	self deny: developer projects isEmpty.
	self assert: group projects isEmpty.
	project addDeveloper: group.
	self assert: project developers size = 2.
	self assert: developer projects size = 1.
	self assert: group projects size = 1.
	self deny: developer projects isEmpty.
	self deny: group projects isEmpty! !

!S2ProjectTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:52'!
testIsEditableBy
	project addAdmin: admin.
	project addDeveloper: developer.
	
	self assert: (project isEditableBy: admin).
	self assert: (project isEditableBy: superuser).
	self deny: (project isEditableBy: developer).
	self deny: (project isEditableBy: user).! !

!S2ProjectTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 13:36'!
testIsVisibleBy
	project addAdmin: admin.
	project addDeveloper: developer.
	
	self assert: (project isVisibleBy: admin).
	self assert: (project isVisibleBy: superuser).
	self assert: (project isVisibleBy: developer).
	self deny: (project isVisibleBy: user).
	
	project visibility: #visible.
	self assert: (project isVisibleBy: user).! !

!S2ProjectTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:19'!
testLicense
	self deny: project license = 'gnu'.
	project license: 'gnu'.
	self assert: project license = 'gnu'.! !

!S2ProjectTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:24'!
testRating
	self assert: project rating = 0.
	project rating: 5.5.
	self assert: project rating = 5.5
	! !

!S2ProjectTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:46'!
testRemoveAdmin
	project addAdmin: group.
	project addAdmin: admin.
	self assert: project admins size = 2.
	self assert: admin projects size = 1.
	self assert: group projects size = 1.
	self deny: project admins isEmpty.
	self deny: admin projects isEmpty.
	self deny: group projects isEmpty.
	project removeAdmin: group.
	self assert: project admins size = 1.
	self assert: admin projects size = 1.
	self assert: group projects size = 0.
	self deny: project admins isEmpty.
	self deny: admin projects isEmpty.
	self assert: group projects isEmpty.
	project removeAdmin: admin.
	self assert: project admins size = 0.
	self assert: admin projects size = 0.
	self assert: group projects size = 0.
	self assert: project admins isEmpty.
	self assert: admin projects isEmpty.
	self assert: group projects isEmpty! !

!S2ProjectTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:45'!
testRemoveDeveloper
	project addDeveloper: group.
	project addDeveloper: developer.
	self assert: project developers size = 2.
	self assert: developer projects size = 1.
	self assert: group projects size = 1.
	self deny: project developers isEmpty.
	self deny: developer projects isEmpty.
	self deny: group projects isEmpty.
	project removeDeveloper: group.
	self assert: project developers size = 1.
	self assert: developer projects size = 1.
	self assert: group projects size = 0.
	self deny: project developers isEmpty.
	self deny: developer projects isEmpty.
	self assert: group projects isEmpty.
	project removeDeveloper: developer.
	self assert: project developers size = 0.
	self assert: developer projects size = 0.
	self assert: group projects size = 0.
	self assert: project developers isEmpty.
	self assert: developer projects isEmpty.
	self assert: group projects isEmpty! !

!S2ProjectTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:22'!
testState
	self assert: project state = 'Created'.
	project state: 'Alpha'.
	self assert: project state = 'Alpha'.
	self deny: project state = 'Created'.
	! !

!S2ProjectTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:59'!
testVisibility
	self deny: project visibility = #writable.
	self deny: project visibility = #visible.
	self assert: project visibility = #hidden.
	project visibility: #visible.
	self assert: project visibility = #visible.
	! !

TestCase subclass: #S2RootTest
	instanceVariableNames: 'root user group project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Tests'!

!S2RootTest methodsFor: 'running' stamp: 'AQ 7/6/2008 20:39'!
setUp
	root := S2Root new.
	group := S2Group new.
	user := S2User new.
	project := S2Project new
	! !

!S2RootTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:44'!
testAddGroup
	self assert: root groups isEmpty.
	root addGroup: group.
	self assert: root groups size = 1.
	self assert: root groups anyOne = group! !

!S2RootTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:45'!
testAddProject
	self assert: root projects isEmpty.
	root addProject: project.
	self assert: root projects size = 1.
	self assert: root projects anyOne = project! !

!S2RootTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:46'!
testAddUser
	self assert: root users isEmpty.
	root addUser: user.
	self assert: root users size = 1.
	self assert: root users anyOne = user! !

!S2RootTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:50'!
testRemoveGroup
	root addGroup: group.
	self assert: root groups size = 1.
	root removeGroup: group.
	self assert: root groups size = 0! !

!S2RootTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:52'!
testRemoveProject
	root addProject: project.
	self assert: root projects size = 1.
	root removeProject: project.
	self assert: root projects size = 0! !

!S2RootTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:50'!
testRemoveUser
	root addUser: user.
	self assert: root users size = 1.
	root removeUser: user.
	self assert: root users size = 0! !

TestCase subclass: #S2UserTest
	instanceVariableNames: 'user superuser user2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Tests'!

!S2UserTest methodsFor: 'running' stamp: 'AQ 7/9/2008 11:54'!
setUp
	user := S2User new.
	superuser := S2User new.
	superuser superuser: true.
	user2 := S2User new.! !

!S2UserTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:15'!
testEmail
	self deny: user email = 'e@mail.net'.
	user email: 'e@mail.net'.
	self assert: user email = 'e@mail.net'! !

!S2UserTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 11:55'!
testIsEditableBy
	self assert: (user isEditableBy: user).
	self deny: (user isEditableBy: user2).
	self assert: (user isEditableBy: superuser).! !

!S2UserTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:33'!
testIsVisibleBy
	self assert: (user isVisibleBy: user).
	self assert: (user isVisibleBy: user2).
	self assert: (user isVisibleBy: superuser).! !

!S2UserTest methodsFor: 'tests' stamp: 'lr 7/9/2008 15:02'!
testPassword
	user password: '12345'.
	self assert: (user verifyPassword: '12345').
	self deny: (user verifyPassword: '1234')! !

!S2UserTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:18'!
testSuperuser
	self deny: user superuser.
	user superuser: true.
	self assert: user superuser! !
S2Root initialize!
S2RootComponent initialize!
